<template>
  <div class="tab-content" v-if="rule.directions">
    <ob-table
      ref="table"
      :columns="tableColumns"
      :items="tableItems"
      :functionalPanel="true"
      :tableLayoutFixed="false"
      :group-by="'group'"
      :isSmartPagination="false"
      @select="onSelect"
      data-qa="distributionsTabTable"
    >
      <template v-slot:point="{ data }">
        <i :class="['icon', data.item.icon.toLowerCase()]"></i>
        {{ data.item.point }}
      </template>

      <template v-slot:percent="{ data }">
        <span :class="data.item.selectedVolume == 100 ? 'full' : ''">{{
          data.item.selectedVolume
        }}% <i class="icon checked-mini" v-if="data.item.selectedVolume == 100"></i></span>
      </template>

      <template v-slot:actions="{ data }">
        <ob-menu-dropdown
          :items="[{ title: 'Удалить направление', method: () => onDelete(data) }]"
          :class="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED' ? 'disabled' : ''"
          trigger="click"
        >
        </ob-menu-dropdown>
      </template>
    </ob-table>
  </div>
</template>

<script>
import {mapGetters } from "vuex";
import obTable from "common-components/src/obComponents/obTable";
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
export default {
  name: "directionsTab",

  components: {
    obTable,
    ObMenuDropdown
  },

  data() {
    return {
      tableColumns: [
        {
          title: "Куда",
          key: "point",
          slotName: 'point'
        },
        {
          title: "заказов распределено",
          key: "selectedVolume",
          slotName: 'percent'
        },
        {
          title: "между исполнителями",
          key: "participantsCount",
        },
        {
          title: '',
          slotName: 'actions',
          action: true,
          isToggleDisabled: true
        }
      ]
    }
  },

  computed: {
    ...mapGetters({
      rule: 'tms/rule'
    }),

    groups() {
      return [...new Set(this.rule.directions.map(item => item.fromLocation.title))];
    },

    tableItems() {
      return this.rule.directions.map(item => {
        return {
          uuid: item.directionUuid,
          point: item.toLocation.title,
          icon: item.toLocation.locationType,
          selectedVolume: item.selectedVolume,
          participantsCount: item.participantsCount,
          groups: this.groups,
          group: item.fromLocation.title
        }
      })
    }
  },

  methods: {
    onSelect(data) {
      this.$emit('selected', data.uuid);
    },

    onDelete(data) {
      console.log('delete ->', data);
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.tab-content {
  padding: 25px;
  height: 100%;
}

.full {
  color: $color-green-light;

  i {
    color: $color-green-light;
  }
}

::v-deep {
  th:nth-child(2) .td-container,
  td:nth-child(2) .td-container,
  th:nth-child(3) .td-container,
  td:nth-child(3) .td-container {
    justify-content: flex-end;
  }

  i {
    margin-right: 5px;
    color: $color-blue-smalt;
  }
}

.disabled {
  pointer-events: none;
}
</style>
